Option Strict Off
Option Explicit On

Imports System
Imports System.IO

Friend Class frmMain
    Inherits System.Windows.Forms.Form

    ' the following variables are used for settings
    Private mDefaultSearchDir As String ' search file directory
    Private mDefaultReportDir As String ' report file directory
    '
    Public mCancelSearch As Boolean
    Private bFormLoading As Boolean = True
    ' in the files that were found, how many contained the search string
    Private mFilesFound As Integer = 0
    ' how many files were found
    Private mFilesSearched As Integer = 0
    '
    ' declarations done.. program start

    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        bFormLoading = True
        mDefaultSearchDir = My.Settings.DefaultSearchDir.ToString
        mDefaultReportDir = My.Settings.DefaultReportDir.ToString
        Me.txtDefaultSearchDir.Text = mDefaultSearchDir
        Me.txtDefaultReportDir.Text = mDefaultReportDir
        Me.txtFiles2Search.Text = My.Settings.SearchFileSpec.ToString
        Me.txtSearchString1.Text = My.Settings.SearchFileFor1.ToString
        Me.txtSearchString2.Text = My.Settings.SearchFileFor2.ToString
        Me.txtSearchString3.Text = My.Settings.SearchFileFor3.ToString
        Me.chkIgnoreCase.Checked = My.Settings.IgnoreCase
        Me.chkMakeReport.Checked = My.Settings.CreateReport
        If My.Settings.UseEditorName.Length < 2 Then
            Me.tsNotSelectedMenu.Text = "Not Selected"
        Else
            Me.tsNotSelectedMenu.Text = My.Settings.UseEditorName.ToString
        End If
        bFormLoading = False
        Me.pnlParms.Focus()
        Me.txtFiles2Search.Focus()
    End Sub

    Private Sub cmdSearchDir_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSearchDir.Click
        Me.FolderBrowserDialog1.ShowNewFolderButton = False
        Me.FolderBrowserDialog1.Description = "Select starting folder to SEARCH"
        If Me.txtDefaultSearchDir.Text.Length > 0 Then
            Me.FolderBrowserDialog1.SelectedPath = Me.txtDefaultSearchDir.Text.ToString
        End If
        If Me.FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.txtDefaultSearchDir.Text = Me.FolderBrowserDialog1.SelectedPath
            mDefaultSearchDir = Me.FolderBrowserDialog1.SelectedPath
            My.Settings.DefaultSearchDir = Me.FolderBrowserDialog1.SelectedPath
            My.Settings.Save()
        End If
    End Sub

    Private Sub cmdReportDir_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdReportDir.Click
        Me.FolderBrowserDialog1.ShowNewFolderButton = True
        Me.FolderBrowserDialog1.Description = "Select Folder To Store Reports"
        If Me.txtDefaultReportDir.Text.Length > 0 Then
            Me.FolderBrowserDialog1.SelectedPath = Me.txtDefaultReportDir.Text.ToString
        End If
        If Me.FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.txtDefaultReportDir.Text = Me.FolderBrowserDialog1.SelectedPath
            mDefaultReportDir = Me.FolderBrowserDialog1.SelectedPath
            My.Settings.DefaultReportDir = Me.FolderBrowserDialog1.SelectedPath
            My.Settings.Save()
        End If
    End Sub

    Private Sub cmdCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCancel.Click
        mCancelSearch = True
    End Sub

    Private Sub cmdSearch_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSearch.Click
        Dim mTimeStart, mTimeStop As Date
        Dim b1 As Boolean = False
        Dim b2 As Boolean = False
        Dim b3 As Boolean = False
        If (Me.mDefaultSearchDir.Length < 2) Then
            Me.cmdSearchDir.Focus()
            MsgBox("Search Folder Not Selected", , "Program Configuration Required")
            Exit Sub
        End If
        If (Me.mDefaultReportDir.Length < 2) And Me.chkMakeReport.Checked Then
            Me.cmdReportDir.Focus()
            MsgBox("Report Folder Not Selected", , "Program Configuration Required")
            Exit Sub
        End If

        If Len(LTrim(Me.txtSearchString1.Text)) > 0 Then
            b1 = True
        End If
        If Len(LTrim(Me.txtSearchString2.Text)) > 0 Then
            b2 = True
        End If
        If Len(LTrim(Me.txtSearchString3.Text)) > 0 Then
            b3 = True
        End If
        If b1 = False And b2 = False And b3 = False Then
            Me.txtSearchString1.Focus()
            MsgBox("Search Text Not Entered")
            Exit Sub
        End If

        If Len(LTrim(Me.txtFiles2Search.Text)) = 0 Then
            Me.txtFiles2Search.Focus()
            MsgBox("Search File Types Not Entered")
            Exit Sub
        End If
        If Not System.IO.Directory.Exists(Me.txtDefaultSearchDir.Text) Then
            MsgBox("Selected Search Directory (" + Me.txtDefaultSearchDir.Text + ") does not exist!", , "Search Directory Invalid")
            Exit Sub
        End If
        ' all tests passed? start the process...
        mTimeStart = Now
        mCancelSearch = False
        Me.lblRptName.Visible = False
        SetControls(False)
        Me.lblFilesFoundSearch.Text = "Search Text found in 0 files."
        Me.lblFilesSearched.Text = "Files Searched: 0"
        mFilesSearched = 0
        mFilesFound = 0
        Me.txtStatus.Text = "One Moment Please... Gathering Directory and File Names"
        Me.ListBox1.Items.Clear()
        Me.grd.Rows.Clear()

        Dim x As New FileSearch()

        x.Search(Me.mDefaultSearchDir, Me.txtFiles2Search.Text, "*")
        Me.txtStatus.Text = "Searched " + x.Directories.Count.ToString("N0") + " directories, found " + x.Files.Count.ToString("N0") + " files. "
        Application.DoEvents()
        'Debug.Print("Files found: " + x.Files.Count.ToString)
        'Debug.Print("Total Directories: " + x.Directories.Count.ToString)
        If x.Files.Count = 0 Then
            SetControls(True)
            Exit Sub
        End If

        Dim rptd As String = Now.Year.ToString + "." + Now.Month.ToString + "." + Now.Day.ToString + "." + Now.TimeOfDay.ToString + ".txt"
        Dim repname As String = rptd.Replace(":", "")
        Dim s1 As String = ""
        Dim fname As String = ""
        Dim grdadded As Boolean = False
        Dim icount1, icount2, icount3 As Integer
        If Me.chkMakeReport.Checked Then
            Using lw As StreamWriter = File.CreateText(Me.txtDefaultReportDir.Text.ToString + "\" + repname)
                lw.WriteLine()
                lw.WriteLine("Path searched: " + Me.txtDefaultSearchDir.Text.ToString)
                lw.WriteLine("File types searched: " + Me.txtFiles2Search.Text.ToString)
                If b1 Then
                    lw.WriteLine("Search string 1: " + Me.txtSearchString1.Text.ToString)
                End If
                If b2 Then
                    lw.WriteLine("Search string 2: " + Me.txtSearchString2.Text.ToString)
                End If
                If b3 Then
                    lw.WriteLine("Search string 3: " + Me.txtSearchString3.Text.ToString)
                End If
                lw.WriteLine("A total of " + x.Files.Count.ToString("N0") + " files were found in " + x.Directories.Count.ToString("N0") + " folders")
                lw.WriteLine("=======================================================")
                lw.Close()
                With Me.lblRptName
                    .Text = "This report is named:" & vbCrLf & vbCrLf & repname
                    .Visible = True
                End With
            End Using
        End If
        For Each thisFile As System.IO.FileInfo In x.Files
            If Me.mCancelSearch = True Then
                Exit For
            End If
            fname = thisFile.FullName.ToString
            Me.txtCurrentFile.Text = "Scaning " + fname
            Application.DoEvents()
            Me.ListBox1.Items.Add(fname)
            mFilesSearched += 1
            lblFilesSearched.Text = "Files Searched: " + mFilesSearched.ToString
            ' read 'this' file in and search for matching text
            grdadded = False
            icount1 = 0
            icount2 = 0
            icount3 = 0
            Try
                Using sr As StreamReader = New StreamReader(fname)
                    Do While Not sr.EndOfStream
                        s1 = sr.ReadLine()
                        If s1 Is Nothing Then
                            Exit Do
                        End If
                        If Me.chkIgnoreCase.Checked Then
                            If b1 Then
                                If s1.ToLower.Contains(Me.txtSearchString1.Text.ToLower) Then
                                    icount1 += 1
                                End If
                            End If
                            If b2 Then
                                If s1.ToLower.Contains(Me.txtSearchString2.Text.ToLower) Then
                                    icount2 += 1
                                End If
                            End If
                            If b3 Then
                                If s1.ToLower.Contains(Me.txtSearchString3.Text.ToLower) Then
                                    icount3 += 1
                                End If
                            End If
                        Else
                            If b1 Then
                                If s1.Contains(Me.txtSearchString1.Text) Then
                                    icount1 += 1
                                End If
                            End If
                            If b2 Then
                                If s1.Contains(Me.txtSearchString2.Text) Then
                                    icount2 += 1
                                End If
                            End If
                            If b3 Then
                                If s1.Contains(Me.txtSearchString3.Text) Then
                                    icount3 += 1
                                End If
                            End If
                        End If
                    Loop
                    If icount1 > 0 Or icount2 > 0 Or icount3 > 0 Then
                        Dim strFoundTimes As String = ""
                        If icount1 > 0 Then
                            strFoundTimes = "1) " + icount1.ToString
                        End If
                        If icount2 > 0 Then
                            If strFoundTimes.Length > 0 Then
                                strFoundTimes += ", 2) " + icount2.ToString
                            Else
                                strFoundTimes += "2) " + icount2.ToString
                            End If
                        End If
                        If icount3 > 0 Then
                            If strFoundTimes.Length > 0 Then
                                strFoundTimes += ", 3) " + icount3.ToString
                            Else
                                strFoundTimes += "3) " + icount3.ToString
                            End If
                        End If
                        Me.grd.Rows.Add("Edit", thisFile.Name.ToString, thisFile.DirectoryName.ToString, thisFile.LastWriteTime.ToString, strFoundTimes)
                        mFilesFound += 1
                        Me.lblFilesFoundSearch.Text = "Search Text found in " + mFilesFound.ToString + " files."
                        If Me.chkMakeReport.Checked Then
                            Using lw As StreamWriter = File.AppendText(Me.txtDefaultReportDir.Text.ToString + "\" + repname)
                                lw.WriteLine(thisFile.DirectoryName.ToString + "\" + thisFile.Name.ToString + "  ... Found item(s) " + strFoundTimes + " times")
                                lw.Close()
                            End Using
                        End If
                    End If
                    sr.Close()
                End Using
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
            ' now grab the next file...
        Next
        mTimeStop = Now
        Me.txtStatus.Text += " Search Matches: " + Me.grd.Rows.Count.ToString
        Dim dif As TimeSpan = mTimeStop - mTimeStart
        If Me.mCancelSearch = True Then
            Me.txtCurrentFile.Text = "SEARCH CANCELLED. Total time: " + dif.TotalSeconds.ToString + " seconds."
            If Me.chkMakeReport.Checked Then
                Using lw As StreamWriter = File.AppendText(Me.txtDefaultReportDir.Text.ToString + "\" + repname)
                    lw.WriteLine()
                    lw.WriteLine("----------------------------------------------------------------")
                    lw.WriteLine("SEARCH CANCELLED. Total time: " + dif.TotalSeconds.ToString + " seconds.")
                    lw.WriteLine(Me.txtStatus.Text.ToString)
                    lw.WriteLine("----------------------------------------------------------------")
                    lw.Close()
                End Using
            End If

        Else
            Me.txtCurrentFile.Text = "Search Completed. Total time: " + dif.TotalSeconds.ToString + " seconds."
            If Me.chkMakeReport.Checked Then
                Using lw As StreamWriter = File.AppendText(Me.txtDefaultReportDir.Text.ToString + "\" + repname)
                    lw.WriteLine()
                    lw.WriteLine("----------------------------------------------------------------")
                    lw.WriteLine("Search Completed. Total time: " + dif.TotalSeconds.ToString + " seconds.")
                    lw.WriteLine(Me.txtStatus.Text.ToString)
                    lw.WriteLine("----------------------------------------------------------------")
                    lw.Close()
                End Using
            End If
        End If
        'Debug.Print("Found " + Me.ListBox1.Items.Count.ToString)
        'Debug.Print("Files with search " + Me.grd.Rows.Count.ToString)

        mCancelSearch = False
        SetControls(True)
    End Sub


    Private Sub SetControls(ByVal b As Boolean)
        With Me
            .pnlConfig.Enabled = b
            .pnlParms.Enabled = b
            If b Then
                .cmdSearch.Enabled = True
                .txtSearchString1.Focus()
                .cmdCancel.Enabled = False
            Else
                .cmdCancel.Enabled = True
                .cmdCancel.Focus()
                .cmdSearch.Enabled = False
            End If
        End With
    End Sub

    Private Sub txtFiles2Search_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFiles2Search.Leave
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.SearchFileSpec = Me.txtFiles2Search.Text.ToString
        My.Settings.Save()
    End Sub

    Private Sub txtSearchString1_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchString1.Leave
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.SearchFileFor1 = Me.txtSearchString1.Text.ToString
        My.Settings.Save()
    End Sub
    Private Sub txtSearchString2_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchString2.Leave
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.SearchFileFor2 = Me.txtSearchString2.Text.ToString
        My.Settings.Save()
    End Sub
    Private Sub txtSearchString3_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSearchString3.Leave
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.SearchFileFor3 = Me.txtSearchString3.Text.ToString
        My.Settings.Save()
    End Sub

    Private Sub chkMakeReport_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkMakeReport.CheckedChanged
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.CreateReport = Me.chkMakeReport.Checked
        My.Settings.Save()
    End Sub

    Private Sub chkIgnoreCase_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkIgnoreCase.CheckedChanged
        If Me.bFormLoading = True Then
            Exit Sub
        End If
        My.Settings.IgnoreCase = Me.chkIgnoreCase.Checked
        My.Settings.Save()
    End Sub

    Private Sub grd_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grd.CellContentClick
        If e.ColumnIndex = 0 And e.RowIndex >= 0 Then
            ' the 'edit' button was clicked...
            If Me.tsNotSelectedMenu.Text.ToString = "Not Selected" Then
                Me.ChooseEditorToolStripMenuItem.Select()
                MsgBox("A default editor has not been selected yet")
                Exit Sub
            End If
            Dim str, proc As String
            str = grd.Rows(e.RowIndex).Cells(2).Value + "\" + grd.Rows(e.RowIndex).Cells(1).Value
            proc = My.Settings.UseEditorPath.ToString + My.Settings.UseEditorName.ToString
            If proc.Length > 4 Then
                Process.Start(proc, str)
            End If
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub tsNotSelectedMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsNotSelectedMenu.Click
        Me.OpenFileDialog1.Title = "Select Your Editor Of Choice..."
        Me.OpenFileDialog1.Filter = "Program files (*.exe)|*.exe"

        If Me.tsNotSelectedMenu.Text = "Not Selected" Then
            Me.OpenFileDialog1.InitialDirectory = "C:\"
            Me.OpenFileDialog1.FileName = ""
        Else
            Me.OpenFileDialog1.InitialDirectory = My.Settings.UseEditorPath.ToString
            Me.OpenFileDialog1.FileName = My.Settings.UseEditorName.ToString
        End If
        If Me.OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim s As String = Me.OpenFileDialog1.FileName.ToString ' full path and name
            Dim exe As String = Me.OpenFileDialog1.SafeFileName.ToString ' just the exe file
            My.Settings.UseEditorName = Me.OpenFileDialog1.SafeFileName.ToString
            My.Settings.UseEditorPath = s.Substring(0, s.Length - exe.Length)
            My.Settings.Save()
            Me.tsNotSelectedMenu.Text = exe
        End If
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        frmAbout.Show()
    End Sub

    Private Sub UseageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UseageToolStripMenuItem.Click
        frmHelp.Show()
    End Sub
End Class